#include <stdio.h>
#include <lua/lua.hpp>

int main() {
	//Luaの新しい環境を生成
	lua_State *L = luaL_newstate();
	
	//Luaの標準ライブラリ読み込み
	luaL_openlibs(L);

	//test.luaをファイルとして読み込んで実行。
	//実行されるとLに一通り実行された状態が記録される。
	if(luaL_dofile(L, "test.lua")) {
		printf("%s\n", lua_tostring(L, -1));
	}

	//test.luaにあるHelloというグローバル変数を取得して文字列で表示
	lua_getglobal(L, "Hello");
	printf("%s\n", lua_tostring(L, -1));
	
	//test.luaにあるWorldというグローバル変数を取得して文字列で表示
	lua_getglobal(L, "World");
	printf("%s\n", lua_tostring(L, -1));
	
	//文字列を直接Luaスクリプトとして実行
	luaL_dostring(L, "print('LUA! LUA!')");

	//Luaの環境を削除
	lua_close(L);
	return 0;
}
